

import numpy as np
from scipy.special import comb



def cubic(P):
    """
    Cubic Bezier curve for four points.
    """

    P = np.asarray(P)
    n = 3

    t = np.linspace(0,1)

    B0 = np.zeros_like(t)
    B1 = np.zeros_like(t)

    for i in range(4):
        print(i)
        bernstein = comb(n, i) * (1 - t)**(n - i) * t**i

        B0 += bernstein * P[i,0]
        B1 += bernstein * P[i,1]

    return B0, B1



def cubic_matrix(C, P=None):
    """
    C: control points
    P: data points
    """
    t = np.linspace(0, 1)

    M = np.array([
        [-1,  3, -3,  1],
        [ 3, -6,  3,  0],
        [-3,  3,  0,  0],
        [ 1,  0,  0,  0]
    ])

    T = np.array([t**3, t**2, t**1, t**0])

    return T, M, C

